/**
 * @file
 * @brief Generated model file.
 * 
 * Date:  2018-07-23 11:20
 * X2C-Version: 6.0.1498
 */
/* This file is part of X2C. http://www.mechatronic-simulation.org/                                                   */

/* Model: DemoApplication                                                                                             */
/* Date:  2018-07-23 11:20                                                                                            */

/* X2C-Version: 6.0.1498                                                                                              */

#ifndef X2C_H
#define X2C_H

#ifdef __cplusplus
extern "C" {
#endif

/**********************************************************************************************************************/
/**     Includes                                                                                                     **/
/**********************************************************************************************************************/
#include "Constant_FiP16.h"
#include "AutoSwitch_FiP16.h"
#include "Gain_FiP16.h"
#include "Delay_FiP16.h"
#include "Constant_Bool.h"
#include "I_FiP16.h"
#include "Negation_FiP16.h"
#include "Sin3Gen_FiP16.h"
#include "SinGen_FiP16.h"
#include "Scope_Main.h"
#include "CommonFcts.h"

/**********************************************************************************************************************/
/**     Defines                                                                                                      **/
/**********************************************************************************************************************/
#define FUNCTIONS \
    CONSTANT_FIP16_FUNCTIONS , \
    AUTOSWITCH_FIP16_FUNCTIONS , \
    GAIN_FIP16_FUNCTIONS , \
    DELAY_FIP16_FUNCTIONS , \
    CONSTANT_BOOL_FUNCTIONS , \
    I_FIP16_FUNCTIONS , \
    NEGATION_FIP16_FUNCTIONS , \
    SIN3GEN_FIP16_FUNCTIONS , \
    SINGEN_FIP16_FUNCTIONS , \
    SCOPE_MAIN_FUNCTIONS

#define PARAMETER_TABLE \
    { 1, &x2cModel.blocks.bAmplitude } , \
    { 2, &x2cModel.blocks.bAutoSwitch } , \
    { 3, &x2cModel.blocks.bAutoSwitch1 } , \
    { 4, &x2cModel.blocks.bFrequency } , \
    { 5, &x2cModel.blocks.bGain } , \
    { 6, &x2cModel.blocks.bLED_off } , \
    { 7, &x2cModel.blocks.bLED_on } , \
    { 8, &x2cModel.blocks.sOscillator.bAutoSwitch } , \
    { 9, &x2cModel.blocks.sOscillator.bConstant } , \
    { 10, &x2cModel.blocks.sOscillator.bDelay } , \
    { 11, &x2cModel.blocks.sOscillator.bEnable } , \
    { 12, &x2cModel.blocks.sOscillator.bInit } , \
    { 13, &x2cModel.blocks.sOscillator.bIntegrator } , \
    { 14, &x2cModel.blocks.sOscillator.bNegation } , \
    { 15, &x2cModel.blocks.bSin3Gen } , \
    { 16, &x2cModel.blocks.bSinGen } , \
    { 20, &x2cScope }

#define INPORT_PARAMID_TABLE \
    { 17, 2, &x2cModel.inports.bB1_User } 

#define OUTPORT_PARAMID_TABLE \
    { 18, 2, &x2cModel.outports.bLD2 } , \
    { 19, 2, &x2cModel.outports.bOsc_out } 


/**********************************************************************************************************************/
/**                                            Model structure definition                                            **/
/**********************************************************************************************************************/
struct x2cModel {
/*  Control Blocks                                                                                                    */
    struct {
/*      Sub-system Oscillator                                                                                         */
        struct {
            AUTOSWITCH_FIP16 bAutoSwitch;
            CONSTANT_FIP16 bConstant;
            DELAY_FIP16 bDelay;
            CONSTANT_BOOL bEnable;
            CONSTANT_FIP16 bInit;
            I_FIP16 bIntegrator;
            NEGATION_FIP16 bNegation;
        } sOscillator;
        CONSTANT_FIP16 bAmplitude;
        AUTOSWITCH_FIP16 bAutoSwitch;
        AUTOSWITCH_FIP16 bAutoSwitch1;
        CONSTANT_FIP16 bFrequency;
        GAIN_FIP16 bGain;
        CONSTANT_FIP16 bLED_off;
        CONSTANT_FIP16 bLED_on;
        SIN3GEN_FIP16 bSin3Gen;
        SINGEN_FIP16 bSinGen;
    } blocks;
/*  Inports                                                                                                           */
    struct {
        int16 bB1_User;
    } inports;
/*  Outports                                                                                                          */
    struct {
        int16* bLD2;
        int16* bOsc_out;
    } outports;
};

/**********************************************************************************************************************/
/**     Externals                                                                                                    **/
/**********************************************************************************************************************/
extern struct x2cModel x2cModel;

extern const tBlockFunctions blockFunctionTable[];
extern const tParameterTable parameterIdTable[];
extern const tIoParamIdEntry inportParamIdTable[];
extern const tIoParamIdEntry outportParamIdTable[];


/**********************************************************************************************************************/
/**     Prototypes                                                                                                   **/
/**********************************************************************************************************************/
void X2C_Init(void);
void X2C_Update(void);
void X2C_Update_1(void);

#ifdef __cplusplus
}
#endif

#endif
